import { resolve } from 'path';
import { makeRe } from 'minimatch';

function ensureArray(thing) {
	if (Array.isArray(thing)) return thing;
	if (thing == undefined) return [];
	return [thing];
}

function createFilter(include, exclude) {
	include = ensureArray(include).map(function (id) {
		return resolve(id);
	}).map(makeRe);
	exclude = ensureArray(exclude).map(function (id) {
		return resolve(id);
	}).map(makeRe);

	return function (id) {
		var included = !include.length;

		include.forEach(function (pattern) {
			if (pattern.test(id)) included = true;
		});

		exclude.forEach(function (pattern) {
			if (pattern.test(id)) included = false;
		});

		return included;
	};
}

function basename(path) {
	return path.split(/(\/|\\)/).pop();
}

function extname(path) {
	var match = /\.[^\.]+$/.exec(basename(path));
	if (!match) return '';
	return match[0];
}
function addExtension(filename) {
	var ext = arguments.length <= 1 || arguments[1] === undefined ? '.js' : arguments[1];

	if (!extname(filename)) filename += ext;
	return filename;
}

export { createFilter, addExtension };
//# sourceMappingURL=pluginutils.es6.js.map
